#pragma once

#include <QString>
#include <memory>

namespace datas {
	class IDataComplex {
	public:
		virtual ~IDataComplex() = default;

		/**
		 * @brief Ƿն.
		 *
		 * \return 
		 */
		virtual bool isEmpty() const = 0;

		/**
		 * @brief ǷArray.
		 * 
		 * \return 
		 */
		virtual bool isArray() const = 0;

		/**
		 * @brief ǷObject.
		 * 
		 * \return 
		 */
		virtual bool isObject() const = 0;
	};

	class IDataArray;
	class IDataObject : public datas::IDataComplex {
	public:
		virtual ~IDataObject() = default;

		/**
		 * @brief һµArray.
		 *
		 * \return
		 */
		virtual std::shared_ptr<IDataArray> newArray() const = 0;;
		/**
		 * @brief һµObject.
		 *
		 * \return
		 */
		virtual std::shared_ptr<IDataObject> newObject() const = 0;
		/**
		 * @brief ȡӶ.
		 * 
		 * \param key
		 * \return 
		 */
		virtual std::shared_ptr<datas::IDataComplex> getChild(const QString &key) const = 0;
		virtual void setChild(const QString &key, std::shared_ptr<datas::IDataComplex> obj) = 0;


		/**
		 * @brief ֵֶָ.
		 *
		 * \param key
		 * \return
		 */
		virtual bool isValueField(const QString& key) const = 0;

		virtual bool getBool(const QString& key) const = 0;
		virtual double getDouble(const QString& key) const = 0;
		virtual int32_t getInt32(const QString& key) const = 0;
		virtual int64_t getInt64(const QString& key) const = 0;
		virtual QString getString(const QString& key) const = 0;

		virtual void setBool(const QString& key, bool value) = 0;
		virtual void setDouble(const QString& key, double value) = 0;
		virtual void setInt32(const QString& key, int32_t value) = 0;
		virtual void setInt64(const QString& key, int64_t value) = 0;
		virtual void setString(const QString& key, const QString& value) = 0;

		virtual QString toText() const = 0;
		virtual void loadFrom(const QString &text) = 0;
	};
	class IDataArray : public datas::IDataComplex {
	public:
		virtual ~IDataArray() = default;

		virtual int32_t size() const = 0;
		virtual std::shared_ptr<datas::IDataComplex> get(int index) const = 0;
		virtual void insert(int index, std::shared_ptr<datas::IDataComplex> value) = 0;
		virtual void append(std::shared_ptr<datas::IDataComplex> value) = 0;
	};


	template<typename T> void dataSet(IDataObject& object, const QString& key, T value);
	template<typename T> T dataGet(IDataObject& object, const QString& key);

}
